package com.dk.mdm.mapper.ivt;

import com.dk.common.mapper.BaseMapper;
import com.dk.mdm.model.pojo.ivt.Inbound;
import com.dk.mdm.model.query.ivt.InboundQuery;
import com.dk.mdm.model.response.ivt.InboundResponse;
import com.dk.mdm.model.response.pur.PurchaseResponse;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
*  入库单 Mapper
*/
@Repository
public interface InboundMapper extends BaseMapper<Inbound>{


    /**
     * @desc   : 根据条件进行查询
     * @author : 于继渤
     * @date : 2024/2/26 10:36
     */
    List<InboundResponse> selectInboundAndItem(InboundQuery inboundQuery);



    /**
     * @desc   : 根据条件进行查询（数量）
     * @author : 于继渤
     * @date : 2024/2/26 10:36
     */
    Long selectInboundAndItemCountByCond(InboundQuery inboundQuery);


    /**
     * @desc   : 根据id查询
     * @date   : 2024/3/9 9:14
     * @author : 寇珊珊
     */
    InboundResponse selectById(@Param("id") String id);


    /**
     * @desc   : 修改金额数量
     * @author : 于继渤
     * @date : 2024/2/26 10:36
     */
    int  updateAmount(Inbound inbound);

    /**
     * @desc   : 条件查询 (采购入库用)
     * @author : 王英杰
     * @date   : 2024/3/8 10:58
     */
    List<InboundResponse> selectByCond(InboundQuery inboundQuery);

    /**
     * @desc   : 条件查询个数 (采购入库用)
     * @author : 王英杰
     * @date   : 2024/3/8 10:58
     */
    Long countByCond(InboundQuery inboundQuery);


    /**
     * @desc   : 根据传入的信息查询数据（采购退货入库办理用）
     * @date   : 2024/3/16 16:28
     * @author : 寇珊珊
     */
    InboundResponse selectMessageByOtherQuery(InboundQuery inboundQuery);


    /**
     * @desc   : 条件查询 --- web端入库办理用
     * @date   : 2024/3/23 9:24
     * @author : 寇珊珊
     */
    List<InboundResponse> selectInbound(InboundQuery inboundQuery);

    /**
     * @desc   : 条件查询 --- web端入库办理用查个数
     * @date   : 2024/3/23 9:24
     * @author : 寇珊珊
     */
    Long selectInboundCond(InboundQuery inboundQuery);

    int updateIntoStatus(Inbound inbound);


    /**
     * @desc   : 条件查询 (采购退货用)
     * @author : 于继渤
     * @date   : 2024/3/8 10:58
     */
    List<InboundResponse> selectByInboundReturnCond(InboundQuery inboundQuery);

    /**
     * @desc   : 条件查询个数 (采购退货用)
     * @author : 于继渤
     * @date   : 2024/3/8 10:58
     */
    Long countByInboundReturnCond(InboundQuery inboundQuery);
    /**
     * @desc : 查看来源单据,总单加明细 采购退货用
     * @author : 于继渤
     * @date : 2024/3/6 10:36
     */
    InboundResponse selectInboundReturnById(@Param("id") String id);

    /**
     * @desc   : 根据来源id查询
     * @date   : 2024/3/9 9:14
     * @author : 寇珊珊
     */
    InboundResponse selectByFromId(@Param("id") String id);


}

